/***************************************************************************
 *   Copyright (C) 2005 by Bertrand Haut                                   *
 *   bertrand.haut@gmail.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COCKTAILFILEPARSER_H
#define COCKTAILFILEPARSER_H

#include <qvaluevector.h>
#include "common.h"

/**
Static class responsible to read & write xml files describing the recipes of some cocktails

@author Bertrand Haut
*/



class cocktailFileParser{
public:
	cocktailFileParser();
	~cocktailFileParser();
	static void readCocktailsFromFile(QString fileName, QValueVector<recipe *>* recipes);
	static void readCocktailsFromFile(QString fileName, QValueVector<recipe *>* recipes, dicoRecipe * dico);
	
	static void writeCocktailsToFile(QString fileName, QValueVector<recipe *>* recipes);
	
private:
	static void readCocktailsFromFile(QString fileName, QValueVector<recipe *>* recipes, bool addToDico, dicoRecipe * dico);
};

#endif
